package com.zksy.web.controller.basicData;

import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmFinanceSupervisionFinancialPenalty;
import com.zksy.system.basicData.service.CrmFinanceSupervisionFinancialPenaltyService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 财金监管-金融监管局处罚Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmFinanceSupervisionFinancialPenalty")
@Api(tags = "财金监管-金融监管局处罚", description = "财金监管-金融监管局处罚desc")
public class CrmFinanceSupervisionFinancialPenaltyController extends BaseController{

    @Autowired
    private CrmFinanceSupervisionFinancialPenaltyService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "财金监管-金融监管局处罚搜索getById")
    public CrmFinanceSupervisionFinancialPenalty getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "财金监管-金融监管局处罚分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "财金监管-金融监管局处罚查询所有")
    public List<CrmFinanceSupervisionFinancialPenalty> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增财金监管-金融监管局处罚
     */
    @PostMapping("/save")
    @ApiOperation(value = "财金监管-金融监管局处罚新增")
    @Log(title = "新增财金监管-金融监管局处罚", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmFinanceSupervisionFinancialPenalty crmFinanceSupervisionFinancialPenalty) {
        return service.save(crmFinanceSupervisionFinancialPenalty);
    }

    /**
     * 修改财金监管-金融监管局处罚
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "财金监管-金融监管局处罚修改")
    @Log(title = "修改财金监管-金融监管局处罚", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmFinanceSupervisionFinancialPenalty crmFinanceSupervisionFinancialPenalty) {
        return service.updateById(crmFinanceSupervisionFinancialPenalty);
    }

    /**
     * 导入财金监管-金融监管局处罚
     */
    @ApiOperation("财金监管-金融监管局处罚导入")
    @Log(title = "财金监管-金融监管局处罚", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmFinanceSupervisionFinancialPenalty> crmFinanceSupervisionFinancialPenaltyAll = service.list();
            List<CrmFinanceSupervisionFinancialPenalty> list = ExcelUtils.readMultipartFile(file, CrmFinanceSupervisionFinancialPenalty.class,CrmFinanceSupervisionFinancialPenalty.class.getDeclaredFields().length - 2);
            if(crmFinanceSupervisionFinancialPenaltyAll != null && crmFinanceSupervisionFinancialPenaltyAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("财金监管-金融监管局处罚导出")
    @Log(title = "财金监管-金融监管局处罚", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmFinanceSupervisionFinancialPenalty> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"财金监管-金融监管局处罚",wrapperList,CrmFinanceSupervisionFinancialPenalty.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "财金监管-金融监管局处罚", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除财金监管-金融监管局处罚", notes = "删除财金监管-金融监管局处罚")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"财金监管-金融监管局处罚模板");
    }
}

